// Auto-generated. Do not edit!

// (in-package rc_silhouettematch_client.srv)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;

//-----------------------------------------------------------

let RegionOfInterest = require('../msg/RegionOfInterest.js');
let rc_common_msgs = _finder('rc_common_msgs');

//-----------------------------------------------------------

class GetRegionsOfInterestRequest {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.region_of_interest_2d_ids = null;
    }
    else {
      if (initObj.hasOwnProperty('region_of_interest_2d_ids')) {
        this.region_of_interest_2d_ids = initObj.region_of_interest_2d_ids
      }
      else {
        this.region_of_interest_2d_ids = [];
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type GetRegionsOfInterestRequest
    // Serialize message field [region_of_interest_2d_ids]
    bufferOffset = _arraySerializer.string(obj.region_of_interest_2d_ids, buffer, bufferOffset, null);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type GetRegionsOfInterestRequest
    let len;
    let data = new GetRegionsOfInterestRequest(null);
    // Deserialize message field [region_of_interest_2d_ids]
    data.region_of_interest_2d_ids = _arrayDeserializer.string(buffer, bufferOffset, null)
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    object.region_of_interest_2d_ids.forEach((val) => {
      length += 4 + _getByteLength(val);
    });
    return length + 4;
  }

  static datatype() {
    // Returns string type for a service object
    return 'rc_silhouettematch_client/GetRegionsOfInterestRequest';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '7d2c2e0e17811a8e7eaaa8ba2c0920a0';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # Description: Returns the configured regions of interest with the requested ids. If no ids are provided, all configured regions of interest are returned.
    
    # Optional
    string[] region_of_interest_2d_ids
    
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new GetRegionsOfInterestRequest(null);
    if (msg.region_of_interest_2d_ids !== undefined) {
      resolved.region_of_interest_2d_ids = msg.region_of_interest_2d_ids;
    }
    else {
      resolved.region_of_interest_2d_ids = []
    }

    return resolved;
    }
};

class GetRegionsOfInterestResponse {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.regions_of_interest = null;
      this.return_code = null;
    }
    else {
      if (initObj.hasOwnProperty('regions_of_interest')) {
        this.regions_of_interest = initObj.regions_of_interest
      }
      else {
        this.regions_of_interest = [];
      }
      if (initObj.hasOwnProperty('return_code')) {
        this.return_code = initObj.return_code
      }
      else {
        this.return_code = new rc_common_msgs.msg.ReturnCode();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type GetRegionsOfInterestResponse
    // Serialize message field [regions_of_interest]
    // Serialize the length for message field [regions_of_interest]
    bufferOffset = _serializer.uint32(obj.regions_of_interest.length, buffer, bufferOffset);
    obj.regions_of_interest.forEach((val) => {
      bufferOffset = RegionOfInterest.serialize(val, buffer, bufferOffset);
    });
    // Serialize message field [return_code]
    bufferOffset = rc_common_msgs.msg.ReturnCode.serialize(obj.return_code, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type GetRegionsOfInterestResponse
    let len;
    let data = new GetRegionsOfInterestResponse(null);
    // Deserialize message field [regions_of_interest]
    // Deserialize array length for message field [regions_of_interest]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.regions_of_interest = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.regions_of_interest[i] = RegionOfInterest.deserialize(buffer, bufferOffset)
    }
    // Deserialize message field [return_code]
    data.return_code = rc_common_msgs.msg.ReturnCode.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    object.regions_of_interest.forEach((val) => {
      length += RegionOfInterest.getMessageSize(val);
    });
    length += rc_common_msgs.msg.ReturnCode.getMessageSize(object.return_code);
    return length + 4;
  }

  static datatype() {
    // Returns string type for a service object
    return 'rc_silhouettematch_client/GetRegionsOfInterestResponse';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '06fa1a7801d31924386d76a5bfa2ac30';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    
    RegionOfInterest[] regions_of_interest
    
    rc_common_msgs/ReturnCode return_code
    
    
    ================================================================================
    MSG: rc_silhouettematch_client/RegionOfInterest
    # Region of Interest.
    # If width and height are both 0, the full image is covered
    
    # id of the ROI
    string id
    
    # leftmost pixel of the ROI
    uint32 offset_x
    
    # topmost pixel of the ROI
    uint32 offset_y
    
    # width of ROI
    uint32 width
    
    # height of ROI.
    uint32 height
    
    ================================================================================
    MSG: rc_common_msgs/ReturnCode
    # This message shall be used in the response of services as a field called return_code.
    # Confer to ReturnCodeConsts message for commonly used return code definitions.
    
    # return codes
    # >=0 - success
    # < 0 - failure
    
    # return code
    int16 value
    
    # return message
    string message
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new GetRegionsOfInterestResponse(null);
    if (msg.regions_of_interest !== undefined) {
      resolved.regions_of_interest = new Array(msg.regions_of_interest.length);
      for (let i = 0; i < resolved.regions_of_interest.length; ++i) {
        resolved.regions_of_interest[i] = RegionOfInterest.Resolve(msg.regions_of_interest[i]);
      }
    }
    else {
      resolved.regions_of_interest = []
    }

    if (msg.return_code !== undefined) {
      resolved.return_code = rc_common_msgs.msg.ReturnCode.Resolve(msg.return_code)
    }
    else {
      resolved.return_code = new rc_common_msgs.msg.ReturnCode()
    }

    return resolved;
    }
};

module.exports = {
  Request: GetRegionsOfInterestRequest,
  Response: GetRegionsOfInterestResponse,
  md5sum() { return '39b028e9ddd12b390b0bf525c23ecdce'; },
  datatype() { return 'rc_silhouettematch_client/GetRegionsOfInterest'; }
};
